
import React from 'react';
import nunjucks from 'nunjucks';
import FormikConnect from './FormikConnect';

var LinkField = function LinkField(props) {
  var item = props.item,
      displayLabel = props.displayLabel;

  return React.createElement(
    'span',
    null,
    React.createElement(
      FormikConnect,
      null,
      function (form) {
        var values = form.values;

        var link = nunjucks.renderString(item.linkTemplate, values);
        var className = item.style === 'button' ? 'ant-btn ant-btn-primary' : '';
        return React.createElement(
          'a',
          { className: className, href: link },
          React.createElement(
            'p',
            null,
            displayLabel
          )
        );
      }
    )
  );
};

export default LinkField;