import startCase from 'lodash/startCase';
import { getDeepObjectValue } from 'validate.js';
import sift from 'sift';

export var getFieldName = function getFieldName(_ref) {
  var target = _ref.target,
      lang = _ref.lang,
      itemKey = _ref.itemKey,
      dashboardList = _ref.dashboardList,
      _ref$dashboardDoc = _ref.dashboardDoc,
      dashboardDoc = _ref$dashboardDoc === undefined ? {} : _ref$dashboardDoc,
      _ref$dashboard = _ref.dashboard,
      dashboard = _ref$dashboard === undefined ? {} : _ref$dashboard,
      _ref$dashboardConfig = _ref.dashboardConfig,
      dashboardConfig = _ref$dashboardConfig === undefined ? {} : _ref$dashboardConfig;

  var i18n = getDeepObjectValue(dashboardConfig, 'i18n.' + lang + '.fields.' + itemKey);
  if (i18n) return i18n;
  if (target === 'filters') {
    return startCase(itemKey);
  }if (target === 'doc') {
    return dashboardDoc.label || dashboard.label || startCase(itemKey);
  }if (target === 'list') {
    return dashboardList.label || dashboard.label || startCase(itemKey);
  }
  throw new Error('getFieldName first argument must be list or doc');
};
export var getI18nLabelName = function getI18nLabelName(_ref2) {
  var lang = _ref2.lang,
      itemKey = _ref2.itemKey,
      _ref2$dashboardConfig = _ref2.dashboardConfig,
      dashboardConfig = _ref2$dashboardConfig === undefined ? {} : _ref2$dashboardConfig;
  return getDeepObjectValue(dashboardConfig, 'i18n.' + lang + '.fields.' + itemKey);
};

export var validateWhen = function validateWhen(values, itemField) {
  var when = itemField.when;

  if (when.equalTo) {
    var value = values[itemField.when.field];
    return when.equalTo === value;
  };
  if (when.conditions) {
    return sift(when.conditions)(values);
  }
  return false;
};