'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _netProvider = require('net-provider');

var _Dashboard = require('./Dashboard');

var _Dashboard2 = _interopRequireDefault(_Dashboard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable react/prefer-stateless-function */
/* eslint-disable max-classes-per-file */


var DashboardWrapper = function (_Component) {
  _inherits(DashboardWrapper, _Component);

  function DashboardWrapper() {
    _classCallCheck(this, DashboardWrapper);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  DashboardWrapper.prototype.render = function render() {
    var _props = this.props,
        renderDefaultScreen = _props.renderDefaultScreen,
        showBreadcrumb = _props.showBreadcrumb,
        syncWithUrl = _props.syncWithUrl,
        rowSelection = _props.rowSelection,
        listTargetKeyPrefix = _props.listTargetKeyPrefix,
        url = _props.url,
        onRow = _props.onRow,
        editAfterSaved = _props.editAfterSaved,
        customRenderField = _props.customRenderField,
        customElements = _props.customElements,
        docProps = _props.docProps,
        listProps = _props.listProps;

    if (!url) {
      return renderDefaultScreen ? renderDefaultScreen(this.props) : '';
    }
    var dashboardData = this.props.dashboardData || [];
    var data = dashboardData.find(function (item) {
      return item.result.name === url;
    });
    if (!data) return '...';
    var dashboardConfig = data.data.dashboardConfig || {};
    return _react2.default.createElement(_Dashboard2.default, {
      key: url,
      url: url,
      canCreate: data.result.canCreate && !dashboardConfig.hideNewButton === true,
      canUpdate: data.result.canUpdate,
      canDelete: data.result.canDelete,
      updateFields: data.result.updateFields,
      createFields: data.result.createFields,
      dashboardConfig: dashboardConfig,
      jsonSchema: data.schema,
      showBreadcrumb: showBreadcrumb,
      syncWithUrl: syncWithUrl,
      rowSelection: rowSelection,
      listTargetKeyPrefix: listTargetKeyPrefix,
      populate: dashboardConfig.populate,
      dashboardData: dashboardData,
      onRow: onRow,
      editAfterSaved: editAfterSaved,
      customRenderField: customRenderField,
      customElements: customElements,
      docProps: docProps,
      listProps: listProps,
      actionButtonsPosition: dashboardConfig.actionButtonsPosition || 'end'
    });
  };

  return DashboardWrapper;
}(_react.Component);

var DashboardApp = function (_Component2) {
  _inherits(DashboardApp, _Component2);

  function DashboardApp() {
    _classCallCheck(this, DashboardApp);

    return _possibleConstructorReturn(this, _Component2.apply(this, arguments));
  }

  DashboardApp.prototype.render = function render() {
    var _this3 = this;

    return _react2.default.createElement(
      _netProvider.Selector,
      { targetKey: 'dashboard' },
      function (_ref) {
        var data = _ref.data;
        return _react2.default.createElement(DashboardWrapper, _extends({ dashboardData: data }, _this3.props));
      }
    );
  };

  return DashboardApp;
}(_react.Component);

exports.default = DashboardApp;


DashboardWrapper.defaultProps = {
  syncWithUrl: true,
  showBreadcrumb: true,
  editAfterSaved: true
};
module.exports = exports['default'];