'use strict';

exports.__esModule = true;
exports.validateWhen = exports.getI18nLabelName = exports.getFieldName = undefined;

var _startCase = require('lodash/startCase');

var _startCase2 = _interopRequireDefault(_startCase);

var _validate = require('validate.js');

var _sift = require('sift');

var _sift2 = _interopRequireDefault(_sift);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getFieldName = exports.getFieldName = function getFieldName(_ref) {
  var target = _ref.target,
      lang = _ref.lang,
      itemKey = _ref.itemKey,
      dashboardList = _ref.dashboardList,
      _ref$dashboardDoc = _ref.dashboardDoc,
      dashboardDoc = _ref$dashboardDoc === undefined ? {} : _ref$dashboardDoc,
      _ref$dashboard = _ref.dashboard,
      dashboard = _ref$dashboard === undefined ? {} : _ref$dashboard,
      _ref$dashboardConfig = _ref.dashboardConfig,
      dashboardConfig = _ref$dashboardConfig === undefined ? {} : _ref$dashboardConfig;

  var i18n = (0, _validate.getDeepObjectValue)(dashboardConfig, 'i18n.' + lang + '.fields.' + itemKey);
  if (i18n) return i18n;
  if (target === 'filters') {
    return (0, _startCase2.default)(itemKey);
  }if (target === 'doc') {
    return dashboardDoc.label || dashboard.label || (0, _startCase2.default)(itemKey);
  }if (target === 'list') {
    return dashboardList.label || dashboard.label || (0, _startCase2.default)(itemKey);
  }
  throw new Error('getFieldName first argument must be list or doc');
};
var getI18nLabelName = exports.getI18nLabelName = function getI18nLabelName(_ref2) {
  var lang = _ref2.lang,
      itemKey = _ref2.itemKey,
      _ref2$dashboardConfig = _ref2.dashboardConfig,
      dashboardConfig = _ref2$dashboardConfig === undefined ? {} : _ref2$dashboardConfig;
  return (0, _validate.getDeepObjectValue)(dashboardConfig, 'i18n.' + lang + '.fields.' + itemKey);
};

var validateWhen = exports.validateWhen = function validateWhen(values, itemField) {
  var when = itemField.when;

  if (when.equalTo) {
    var value = values[itemField.when.field];
    return when.equalTo === value;
  };
  if (when.conditions) {
    return (0, _sift2.default)(when.conditions)(values);
  }
  return false;
};